/* Generated by CIL v. 1.7.3 */
/* print_CIL_Input is true */

#line 19 "triangle_wException.c"
void __globinit_triangle_wException(void) ;
extern void __CrestInit(void)  __attribute__((__crest_skip__)) ;
extern void __CrestHandleReturn(int id , long long val )  __attribute__((__crest_skip__)) ;
extern void __CrestReturn(int id )  __attribute__((__crest_skip__)) ;
extern void __CrestCall(int id , unsigned int fid )  __attribute__((__crest_skip__)) ;
extern void __CrestBranch(int id , int bid , unsigned char b )  __attribute__((__crest_skip__)) ;
extern void __CrestApply2(int id , int op , long long val )  __attribute__((__crest_skip__)) ;
extern void __CrestApply1(int id , int op , long long val )  __attribute__((__crest_skip__)) ;
extern void __CrestClearStack(int id )  __attribute__((__crest_skip__)) ;
extern void __CrestStore(int id , unsigned long addr )  __attribute__((__crest_skip__)) ;
extern void __CrestLoad(int id , unsigned long addr , long long val )  __attribute__((__crest_skip__)) ;
#line 212 "/usr/lib/gcc/x86_64-linux-gnu/4.8/include/stddef.h"
typedef unsigned long size_t;
#line 131 "/usr/include/x86_64-linux-gnu/bits/types.h"
typedef long __off_t;
#line 132 "/usr/include/x86_64-linux-gnu/bits/types.h"
typedef long __off64_t;
#line 44 "/usr/include/stdio.h"
struct _IO_FILE;
#line 44
struct _IO_FILE;
#line 48 "/usr/include/stdio.h"
typedef struct _IO_FILE FILE;
#line 144 "/usr/include/libio.h"
struct _IO_FILE;
#line 154 "/usr/include/libio.h"
typedef void _IO_lock_t;
#line 160 "/usr/include/libio.h"
struct _IO_marker {
   struct _IO_marker *_next ;
   struct _IO_FILE *_sbuf ;
   int _pos ;
};
#line 245 "/usr/include/libio.h"
struct _IO_FILE {
   int _flags ;
   char *_IO_read_ptr ;
   char *_IO_read_end ;
   char *_IO_read_base ;
   char *_IO_write_base ;
   char *_IO_write_ptr ;
   char *_IO_write_end ;
   char *_IO_buf_base ;
   char *_IO_buf_end ;
   char *_IO_save_base ;
   char *_IO_backup_base ;
   char *_IO_save_end ;
   struct _IO_marker *_markers ;
   struct _IO_FILE *_chain ;
   int _fileno ;
   int _flags2 ;
   __off_t _old_offset ;
   unsigned short _cur_column ;
   signed char _vtable_offset ;
   char _shortbuf[1] ;
   _IO_lock_t *_lock ;
   __off64_t _offset ;
   void *__pad1 ;
   void *__pad2 ;
   void *__pad3 ;
   void *__pad4 ;
   size_t __pad5 ;
   int _mode ;
   char _unused2[(15UL * sizeof(int ) - 4UL * sizeof(void *)) - sizeof(size_t )] ;
};
#line 202 "../bin/../include/crest.h"
extern void __CrestInt(int *x )  __attribute__((__crest_skip__)) ;
#line 170 "/usr/include/stdio.h"
extern struct _IO_FILE *stderr ;
#line 356
extern int fprintf(FILE * __restrict  __stream , char const   * __restrict  __format 
                   , ...) ;
#line 69 "/usr/include/assert.h"
extern  __attribute__((__nothrow__, __noreturn__)) void ( __attribute__((__leaf__)) __assert_fail)(char const   *__assertion ,
                                                                                                   char const   *__file ,
                                                                                                   unsigned int __line ,
                                                                                                   char const   *__function ) ;
#line 19 "triangle_wException.c"
int main(void) 
{ 
  int a ;
  int b ;
  int c ;
  int __retres4 ;

  {
  __globinit_triangle_wException();
  __CrestCall(1, 1);
#line 21
  __CrestInt(& a);
#line 22
  __CrestInt(& b);
#line 23
  __CrestInt(& c);
  __CrestLoad(4, (unsigned long )(& a), (long long )a);
  __CrestLoad(3, (unsigned long )0, (long long )0);
  __CrestApply2(2, 15, (long long )(a <= 0));
#line 25
  if (a <= 0) {
    __CrestBranch(5, 3, 1);
    __CrestLoad(7, (unsigned long )0, (long long )26U);
#line 26
    __assert_fail("0", "triangle_wException.c", 26U, "main");
    __CrestClearStack(8);
  } else {
    __CrestBranch(6, 4, 0);
    {
    __CrestLoad(11, (unsigned long )(& b), (long long )b);
    __CrestLoad(10, (unsigned long )0, (long long )0);
    __CrestApply2(9, 15, (long long )(b <= 0));
#line 27
    if (b <= 0) {
      __CrestBranch(12, 5, 1);
      __CrestLoad(14, (unsigned long )0, (long long )28U);
#line 28
      __assert_fail("0", "triangle_wException.c", 28U, "main");
      __CrestClearStack(15);
    } else {
      __CrestBranch(13, 6, 0);
      {
      __CrestLoad(18, (unsigned long )(& c), (long long )c);
      __CrestLoad(17, (unsigned long )0, (long long )0);
      __CrestApply2(16, 15, (long long )(c <= 0));
#line 29
      if (c <= 0) {
        __CrestBranch(19, 7, 1);
        __CrestLoad(21, (unsigned long )0, (long long )30U);
#line 30
        __assert_fail("0", "triangle_wException.c", 30U, "main");
        __CrestClearStack(22);
      } else {
        __CrestBranch(20, 8, 0);
        {
        __CrestLoad(27, (unsigned long )(& a), (long long )a);
        __CrestLoad(26, (unsigned long )(& b), (long long )b);
        __CrestApply2(25, 0, (long long )(a + b));
        __CrestLoad(24, (unsigned long )(& c), (long long )c);
        __CrestApply2(23, 15, (long long )(a + b <= c));
#line 31
        if (a + b <= c) {
          __CrestBranch(28, 9, 1);
          __CrestLoad(30, (unsigned long )0, (long long )32U);
#line 32
          __assert_fail("0", "triangle_wException.c", 32U, "main");
          __CrestClearStack(31);
        } else {
          __CrestBranch(29, 10, 0);
          {
          __CrestLoad(36, (unsigned long )(& a), (long long )a);
          __CrestLoad(35, (unsigned long )(& c), (long long )c);
          __CrestApply2(34, 0, (long long )(a + c));
          __CrestLoad(33, (unsigned long )(& b), (long long )b);
          __CrestApply2(32, 15, (long long )(a + c <= b));
#line 33
          if (a + c <= b) {
            __CrestBranch(37, 11, 1);
            __CrestLoad(39, (unsigned long )0, (long long )34U);
#line 34
            __assert_fail("0", "triangle_wException.c", 34U, "main");
            __CrestClearStack(40);
          } else {
            __CrestBranch(38, 12, 0);
            {
            __CrestLoad(45, (unsigned long )(& b), (long long )b);
            __CrestLoad(44, (unsigned long )(& c), (long long )c);
            __CrestApply2(43, 0, (long long )(b + c));
            __CrestLoad(42, (unsigned long )(& a), (long long )a);
            __CrestApply2(41, 15, (long long )(b + c <= a));
#line 35
            if (b + c <= a) {
              __CrestBranch(46, 13, 1);
              __CrestLoad(48, (unsigned long )0, (long long )36U);
#line 36
              __assert_fail("0", "triangle_wException.c", 36U, "main");
              __CrestClearStack(49);
            } else {
              __CrestBranch(47, 14, 0);

            }
            }
          }
          }
        }
        }
      }
      }
    }
    }
  }
  __CrestLoad(52, (unsigned long )(& a), (long long )a);
  __CrestLoad(51, (unsigned long )(& b), (long long )b);
  __CrestApply2(50, 12, (long long )(a == b));
#line 39
  if (a == b) {
    __CrestBranch(53, 16, 1);
    {
    __CrestLoad(57, (unsigned long )(& b), (long long )b);
    __CrestLoad(56, (unsigned long )(& c), (long long )c);
    __CrestApply2(55, 12, (long long )(b == c));
#line 40
    if (b == c) {
      __CrestBranch(58, 17, 1);
#line 41
      fprintf((FILE * __restrict  )stderr, (char const   * __restrict  )"EQUILATERAL\n");
      __CrestClearStack(60);
      __CrestLoad(61, (unsigned long )0, (long long )0);
      __CrestStore(62, (unsigned long )(& __retres4));
#line 42
      __retres4 = 0;
#line 42
      goto return_label;
    } else {
      __CrestBranch(59, 20, 0);
#line 44
      fprintf((FILE * __restrict  )stderr, (char const   * __restrict  )"ISOSCELES\n");
      __CrestClearStack(63);
      __CrestLoad(64, (unsigned long )0, (long long )0);
      __CrestStore(65, (unsigned long )(& __retres4));
#line 45
      __retres4 = 0;
#line 45
      goto return_label;
    }
    }
  } else {
    __CrestBranch(54, 23, 0);
    {
    __CrestLoad(68, (unsigned long )(& a), (long long )a);
    __CrestLoad(67, (unsigned long )(& c), (long long )c);
    __CrestApply2(66, 12, (long long )(a == c));
#line 47
    if (a == c) {
      __CrestBranch(69, 24, 1);
#line 48
      fprintf((FILE * __restrict  )stderr, (char const   * __restrict  )"ISOSCELES\n");
      __CrestClearStack(71);
      __CrestLoad(72, (unsigned long )0, (long long )0);
      __CrestStore(73, (unsigned long )(& __retres4));
#line 49
      __retres4 = 0;
#line 49
      goto return_label;
    } else {
      __CrestBranch(70, 27, 0);
      {
      __CrestLoad(76, (unsigned long )(& b), (long long )b);
      __CrestLoad(75, (unsigned long )(& c), (long long )c);
      __CrestApply2(74, 12, (long long )(b == c));
#line 51
      if (b == c) {
        __CrestBranch(77, 28, 1);
#line 52
        fprintf((FILE * __restrict  )stderr, (char const   * __restrict  )"ISOSCELES\n");
        __CrestClearStack(79);
        __CrestLoad(80, (unsigned long )0, (long long )0);
        __CrestStore(81, (unsigned long )(& __retres4));
#line 53
        __retres4 = 0;
#line 53
        goto return_label;
      } else {
        __CrestBranch(78, 31, 0);
#line 55
        fprintf((FILE * __restrict  )stderr, (char const   * __restrict  )"SCALENE\n");
        __CrestClearStack(82);
        __CrestLoad(83, (unsigned long )0, (long long )0);
        __CrestStore(84, (unsigned long )(& __retres4));
#line 56
        __retres4 = 0;
#line 56
        goto return_label;
      }
      }
    }
    }
  }
  return_label: /* CIL Label */ 
  {
  __CrestLoad(85, (unsigned long )(& __retres4), (long long )__retres4);
  __CrestReturn(86);
#line 19
  return (__retres4);
  }
}
}
void __globinit_triangle_wException(void) 
{ 


  {
  __CrestInit();
}
}
